module ProfileEditorHelper

  include GetText

  AREAS_OF_STUDY = [
    N_('Agrometeorology'),
    N_('Agronomy'),
    N_('Foods'),
    N_('Anthropology'),
    N_('Architecture'),
    N_('Arts'),
    N_('Astronomy'),
    N_('Librarianship'),
    N_('Biosciences'),
    N_('Biophysics'),
    N_('Biology'),
    N_('Biotechnology'),
    N_('Botany'),
    N_('Science Politics'),
    N_('Accounting and Actuarial Science'),
    N_('Morphologic Sciences'),
    N_('Computation'),
    N_('Rural Development'),
    N_('Law'),
    N_('Ecology'),
    N_('Economy'),
    N_('Education'),
    N_('Long-distance Education'),
    N_('Physical Education'),
    N_('Professional Education'),
    N_('Nursing'),
    N_('Engineerings'),
    N_('Basic and Average education'),
    N_('Statistics'),
    N_('Stratigraphy'),
    N_('Pharmacy'),
    N_('Pharmacology'),
    N_('Philosophy'),
    N_('Physics'),
    N_('Plant Protection'),
    N_('Genetics'),
    N_('Geosciences'),
    N_('Geography'),
    N_('Geology'),
    N_('Hydrology'),
    N_('Hydromechanics'),
    N_('History'),
    N_('Horticulture'),
    N_('Informatics'),
    N_('Interdisciplinary'),
    N_('Journalism'),
    N_('Letters'),
    N_('Languages'),
    N_('Mathematics'),
    N_('Medicines'),
    N_('Medicine'),
    N_('Metallurgy'),
    N_('Microbiology'),
    N_('Mineralogy'),
    N_('Music'),
    N_('Nutrition'),
    N_('Odontology'),
    N_('Paleontology'),
    N_('Petrology'),
    N_('Production'),
    N_('Psychology'),
    N_('Psychiatry'),
    N_('Quality'),
    N_('Chemistry'),
    N_('Health'),
    N_('Remote Sensing'),
    N_('Forestry'),
    N_('Sociology'),
    N_('Ground'),
    N_('Theater'),
    N_('Transport'),
    N_('Urbanism'),
    N_('Veterinary Medicine'),
    N_('Zoology'),
    N_('Zootecnia'),
    N_('Others')
  ]

  COUNTRIES = [
    ("Afeganistão (افغانستان)"),
    ("África do Sul (South Africa)"),
    ("Albânia (Shqipëria)"),
    ("Alemanha (Deutschland)"),
    ("Andorra"),
    ("Angola"),
    ("Anguila (Anguilla)"),
    ("Antártica (Antarctica)"),
    ("Antígua e Barbuda (Antigua and Barbuda)"),
    ("Antilhas Holandesas (Netherlands Antilles)"),
    ("Arábia Saudita (العربية السعودية)"),
    ("Argélia (الجمهورية الجزائرية)"),
    ("Argentina"),
    ("Armênia (Հայաստան)"),
    ("Aruba"),
    ("Austrália (Australia)"),
    ("Áustria (Österreich)"),
    ("Azerbaijão (Azərbaycan)"),
    ("Bahamas"),
    ("Bangladesh (বাংলাদেশ)"),
    ("Barbados"),
    ("Barein (بحرين)"),
    ("Bélgica (België)"),
    ("Belize"),
    ("Benin (Bénin)"),
    ("Bermudas (Bermuda)"),
    ("Bielo-Rússia (Белару́сь)"),
    ("Bolívia (Bolivia)"),
    ("Bósnia-Herzegovina (Bosna i Hercegovina)"),
    ("Botsuana (Botswana)"),
    ("Brasil"),
    ("Brunei (Brunei Darussalam)"),
    ("Bulgária (България)"),
    ("Burkina Fasso (Burkina Faso)"),
    ("Burundi (Uburundi)"),
    ("Butão (འབྲུག་ཡུལ)"),
    ("Cabo Verde"),
    ("Camarões (Cameroun)"),
    ("Camboja (Kampuchea)"),
    ("Canadá (Canada)"),
    ("Catar (قطر)"),
    ("Cazaquistão (Қазақстан)"),
    ("Chade (Tchad)"),
    ("Chile"),
    ("China (中国)"),
    ("Chipre (Κυπρος)"),
    ("Cidade do Vaticano (Città del Vaticano)"),
    ("Cingapura (Singapura)"),
    ("Colômbia (Colombia)"),
    ("Comores"),
    ("Congo"),
    ("Congo, República democrática do (Congo, Democratic Republic of the)"),
    ("Coréia do Norte (조선)"),
    ("Coréia do Sul (한국)"),
    ("Costa do Marfim (Côte d'Ivoire)"),
    ("Costa Rica"),
    ("Croácia (Hrvatska)"),
    ("Cuba"),
    ("Dinamarca (Danmark)"),
    ("Djibuti (Djibouti)"),
    ("Dominica"),
    ("Egito (مصر)"),
    ("El Salvador"),
    ("Emirados Árabes Unidos (الإمارات العربيّة المتّحد)"),
    ("Equador (Ecuador)"),
    ("Eritréia (Ertra)"),
    ("Eslováquia (Slovensko)"),
    ("Eslovênia (Slovenija)"),
    ("Espanha (España)"),
    ("Estados Unidos (United States)"),
    ("Estônia (Eesti)"),
    ("Etiópia (Ityop'iya)"),
    ("Fiji"),
    ("Filipinas (Pilipinas)"),
    ("Finlândia (Suomi)"),
    ("França (France)"),
    ("Gabão (Gabon)"),
    ("Gâmbia (Gambia)"),
    ("Gana (Ghana)"),
    ("Geórgia (საქართველო)"),
    ("Geórgia do Sul e Ilhas Sandwich do Sul (South Georgia and the South Sandwich Islands)"),
    ("Gibraltar"),
    ("Granada (Grenada)"),
    ("Grécia (Eλλας)"),
    ("Groenlândia (Greenland)"),
    ("Guadalupe (Guadeloupe)"),
    ("Guam"),
    ("Guatemala"),
    ("Guernsey"),
    ("Guiana (Guyana)"),
    ("Guiana Francesa (French Guiana)"),
    ("Guiné (Guinée)"),
    ("Guiné-Bissau"),
    ("Guiné Equatorial (Guinea Ecuatorial)"),
    ("Haiti (Haïti)"),
    ("Holanda (Nederland)"),
    ("Honduras"),
    ("Hong Kong"),
    ("Hungria (Magyarország)"),
    ("Iêmen (اليمن)"),
    ("Ilha Aland (Aland Islands)"),
    ("Ilha Bouvet (Bouvet Island)"),
    ("Ilha Christmas (Christmas Island)"),
    ("Ilha de Man (Isle of Man)"),
    ("Ilha Norfolk (Norfolk Island)"),
    ("Ilhas Cayman (Cayman Islands)"),
    ("Ilhas Cocos (Keeling) (Cocos Islands)"),
    ("Ilhas Cook (Cook Islands)"),
    ("Ilhas Falkland (Malvinas) (Falkland Islands)"),
    ("Ilhas Faroé (Faroe Islands)"),
    ("Ilhas Heard e McDonald (Heard Island and McDonald Islands)"),
    ("Ilhas Marianas do Norte (Northern Mariana Islands)"),
    ("Ilhas Marshall (Marshall Islands)"),
    ("Ilhas Maurício (Mauritius)"),
    ("Ilhas Reunião (Reunion)"),
    ("Ilhas Salomão (Solomon Islands)"),
    ("Ilhas Svalbard e Jan Mayen (Svalbard and Jan Mayen)"),
    ("Ilhas Tokelau (Tokelau)"),
    ("Ilhas Turks e Caicos (Turks and Caicos Islands)"),
    ("Ilhas Virgens, Britânicas (Virgin Islands, British)"),
    ("Ilhas Virgens, EUA (Virgin Islands, U.S.)"),
    ("Ilhas Wallis e Futuna (Wallis and Futuna)"),
    ("Índia (India)"),
    ("Indonésia (Indonesia)"),
    ("Irã (ایران)"),
    ("Iraque (العراق)"),
    ("Irlanda (Ireland)"),
    ("Islândia (Ísland)"),
    ("Israel (ישראל)"),
    ("Itália (Italia)"),
    ("Jamaica"),
    ("Japão (日本)"),
    ("Jordânia (الارد)"),
    ("Kiribati"),
    ("Kuwait (الكويت)"),
    ("Laos (ນລາວ)"),
    ("Lesoto (Lesotho)"),
    ("Letônia (Latvija)"),
    ("Líbano (لبنان)"),
    ("Libéria (Liberia)"),
    ("Líbia (ليبية)"),
    ("Liechtenstein"),
    ("Lituânia (Lietuva)"),
    ("Luxemburgo (Lëtzebuerg)"),
    ("Macau (Macao)"),
    ("Macedônia (Македонија)"),
    ("Madagáscar (Madagasikara)"),
    ("Maiote (Mayotte)"),
    ("Malásia (Malaysia)"),
    ("Malavi (Malawi)"),
    ("Maldivas (ގުޖޭއްރާ ޔާއްރިހޫމްޖ)"),
    ("Mali"),
    ("Malta"),
    ("Marrocos (مغرب)"),
    ("Martinica (Martinique)"),
    ("Mauritânia (موريتانية)"),
    ("México"),
    ("Micronésia (Micronesia)"),
    ("Moçambique"),
    ("Moldávia (Moldova)"),
    ("Mônaco (Monaco)"),
    ("Mongólia (Монгол Улс)"),
    ("Montserrat"),
    ("Myanmar (Լեռնային Ղարաբաղ)"),
    ("Namíbia (Namibia)"),
    ("Nauru (Naoero)"),
    ("Nepal (नेपाल)"),
    ("Nicarágua (Nicaragua)"),
    ("Níger (Niger)"),
    ("Nigéria (Nigeria)"),
    ("Niue"),
    ("Noruega (Norge)"),
    ("Nova Caledônia (New Caledonia)"),
    ("Nova Jérsei (Jersey)"),
    ("Nova Zelândia (New Zealand)"),
    ("Omã (عمان)"),
    ("Palau (Belau)"),
    ("Palestina (Palestine)"),
    ("Panamá"),
    ("Papua-Nova Guiné (Papua New Guinea)"),
    ("Paquistão (پاکستان)"),
    ("Paraguai (Paraguay)"),
    ("Peru (Perú)"),
    ("Pitcairn"),
    ("Polinésia Francesa (French Polynesia)"),
    ("Polônia (Polska)"),
    ("Porto Rico (Puerto Rico)"),
    ("Portugal"),
    ("Quênia (Kenya)"),
    ("Quirquistão (Кыргызстан)"),
    ("Reino Unido (United Kingdom)"),
    ("República Centro-Africana (République Centrafricaine)"),
    ("República Dominicana (Dominican Republic)"),
    ("República Tcheca (Česko)"),
    ("Romênia (România)"),
    ("Ruanda (Rwanda)"),
    ("Rússia (Россия)"),
    ("Saara Ocidental (صحراوية)"),
    ("Samoa"),
    ("Samoa Americana (American Samoa)"),
    ("San Marino"),
    ("Santa Helena (Saint Helena)"),
    ("Santa Lúcia (Saint Lucia)"),
    ("São Cristóvão e Névis (Saint Kitts and Nevis)"),
    ("São Pierre e Miquelon (Saint Pierre and Miquelon)"),
    ("São Tomé e Príncipe (São Tomé and Príncipe)"),
    ("São Vincente e Granadinas (Saint Vincent and the Grenadines)"),
    ("Seicheles (Seychelles)"),
    ("Senegal (Sénégal)"),
    ("Serra Leoa (Sierra Leone)"),
    ("Sérvia e Montenegro (Србија и Црна Гора)"),
    ("Síria (سورية)"),
    ("Somália (Soomaaliya)"),
    ("Sri Lanka"),
    ("Suazilândia (Swaziland)"),
    ("Sudão (السودان)"),
    ("Suécia (Sverige)"),
    ("Suíça (Schweiz)"),
    ("Suriname"),
    ("Tailândia (ราชอาณาจักรไทย)"),
    ("Taiwan (台灣)"),
    ("Tajiquistão (Тоҷикистон)"),
    ("Tanzânia (Tanzania)"),
    ("Território Britânico do Oceano Índico (British Indian Ocean Territory)"),
    ("Territórios Franceses do Sul (French Southern Territories)"),
    ("Territórios Insulares dos Estados Unidos (United States minor outlying islands)"),
    ("Timor Leste (Timor-Leste)"),
    ("Togo"),
    ("Tonga"),
    ("Trinidad e Tobago (Trinidad and Tobago)"),
    ("Tunísia (تونس)"),
    ("Turcomenistão (Türkmenistan)"),
    ("Turquia (Türkiye)"),
    ("Tuvalu"),
    ("Ucrânia (Україна)"),
    ("Uganda"),
    ("Uruguai (Uruguay)"),
    ("Uzbequistão (O'zbekiston)"),
    ("Vanuatu"),
    ("Venezuela"),
    ("Vietnã (Việt Nam)"),
    ("Zâmbia (Zambia)"),
    ("Zimbábue (Zimbabwe)")
  ]

  SCHOOLING = [
    N_('Post-Doctoral'),
    N_('Ph.D.'),
    N_('Masters'),
    N_('Undergraduate'),
    N_('Graduate'),
    N_('High School'),
    N_('Elementary School')
  ]

  SCHOOLING_STATUS = [
    N_('Concluded'),
    N_('Incomplete'),
    N_('Ongoing')
  ]

  def select_area(title, object, method, options)
    labelled_form_field(title, select(object, method, [[_('[Select ...]'), nil]] + ProfileEditorHelper::AREAS_OF_STUDY.map{|s| [gettext(s), s]}, {}, options))
  end

  def select_country(title, object, method, options)
    labelled_form_field(title, select(object, method, [[_('[Select ...]'), nil]] + ProfileEditorHelper::COUNTRIES.map{|s| [s]}, {}, options))
  end

  def select_schooling(object, method, options)
    select(object, method, [[_('[Select ...]'), nil]] + ProfileEditorHelper::SCHOOLING.map{|s| [gettext(s), s]}, {}, options)
  end

  def select_schooling_status(object, method, options)
    select(object, method, [[_('[Select ...]'), nil]] + ProfileEditorHelper::SCHOOLING_STATUS.map{|s| [gettext(s), s]}, {}, options)
  end

end
